## mah-jong 1.17

=== debian/changelog ===
mah-jong (1.17-1) unstable; urgency=medium

  * New upstream version 1.17
  * Refresh patch
  * Bump Standards-Version: 4.7.2
  * d/copyright: update year info
  * d/copyright: fix old-fsf-address-in-copyright-file

 -- xiao sheng wen <atzlinux@sina.com>  Sun, 27 Apr 2025 09:32:26 +0800
