=== debian/control ===
Source: mah-jong
Section: games
Priority: optional
Maintainer: xiao sheng wen <atzlinux@sina.com>
Build-Depends:
 debhelper-compat (= 13),
 libgtk2.0-dev,
 pkgconf,
Standards-Version: 4.7.2
Homepage: https://mahjong.julianbradfield.org/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/atzlinux-guest/mah-jong
Vcs-Git: https://salsa.debian.org/atzlinux-guest/mah-jong.git

Package: mah-jong
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Original Mah-Jong game
 This is a set of programs to play the original Mah-Jong game: one
 server, one client for a human player and one client for an AI
 player. Hence the game can be played by 1 to 4 human players.
 .
 You should keep in mind that the original Mah-Jong game has nothing
 to do with the well-known solitaire game. (It merely uses the same
 set of tiles.)
 .
 If you like the game, please consider making a donation to the
 (upstream) author. Read /usr/share/doc/mah-jong/README.Debian for
 details.
