=== debian/changelog ===
mah-jong (1.17.2-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * d/rules: Fix FTCBFS: Include C standard in CC. (Closes: #1129219)

 -- xiao sheng wen <atzlinux@sina.com>  Sat, 28 Feb 2026 10:58:34 +0800

mah-jong (1.17.2-2) unstable; urgency=medium

  * add d/p/0001-Port-GUI-from-GTK-2-to-GTK-3.patch, Closes: #967620,
    Thanks Bastian Germann
  * Bump Standards-Version: 4.7.3
  * d/control:
      - set B-D to libgtk-3-dev, not use libgtk2.0-dev
      - delete Rules-Requires-Root: no, useless
  * update d/p/cross.patch, run this patch last
  * d/copyright: update year info to 2026

 -- xiao sheng wen <atzlinux@sina.com>  Wed, 04 Feb 2026 10:01:56 +0800

mah-jong (1.17.2-1) unstable; urgency=medium

  * New upstream version 1.17.2
  * d/p/cross.patch: update for new upstream version
  * rm d/p/gcc-15.patch, useless
  * d/control: re-add Rules-Requires-Root: no

 -- xiao sheng wen <atzlinux@sina.com>  Wed, 10 Sep 2025 12:30:14 +0800

mah-jong (1.17-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with GCC-15 (Closes: #1097353)

 -- Alexandre Detiste <tchet@debian.org>  Tue, 09 Sep 2025 21:18:28 +0200
