=== debian/control ===
--- 
+++ 
@@ -4,11 +4,10 @@
 Maintainer: xiao sheng wen <atzlinux@sina.com>
 Build-Depends:
  debhelper-compat (= 13),
- libgtk2.0-dev,
+ libgtk-3-dev,
  pkgconf,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://mahjong.julianbradfield.org/
-Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/atzlinux-guest/mah-jong
 Vcs-Git: https://salsa.debian.org/atzlinux-guest/mah-jong.git
