=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildtools.mk

%:
	dh  $@

execute_before_dh_auto_clean:
	cp version.h debian/version.h.sav
	cp Makefile debian/Makefile.sav
execute_after_dh_auto_clean:
	mv debian/version.h.sav version.h
	mv debian/Makefile.sav Makefile

execute_before_dh_auto_configure:
	cp Makefile debian/Makefile.sav
	rm -fv Makefile
	make -f Makefile.in Makefile

override_dh_auto_build:
	# debhelper overrides CC but upstream uses it convey the standard
	dh_auto_build -- CC='$(CC) -std=gnu99'

execute_after_dh_install:
	make install.man DESTDIR=$(CURDIR)/debian/mah-jong/ MANDIR=usr/share/man/man6
	mv debian/Makefile.sav Makefile
